from bdflib import reader
import sys

with open("Bm437IBMVGA8x16-16.bdf", "rb") as handle:
    font = reader.read_bdf(handle)

Width  =  8
Height = 16
Unterlaengen = 4

Out = []

for G in font.glyphs:
    Result = [ ['0']*Width for i in range(Height)]
    Xstart = G.bbX
    Yend   = G.bbY
    Data   = G.data
    #print(G.codepoint)

    Y = Height - len(Data) - Unterlaengen - Yend
    while len(Data) > 0:
        X    = Xstart
        Val  = Data.pop()
        Bits = Width - Xstart
        Fmt  = "{0:0" + str(Bits) + "b}"
#        print(Fmt)
        Line = list(Fmt.format(Val))
        while len(Line) > 0:
            Bit       = Line.pop(0)
            if Bit == '1':
                Result[Y][X] = "1"
            X = X + 1
        Y = Y + 1

    Out.append(Result)

Parts = 0
for R in Out:   
    for Line in R:
        # Line[::-1] reverses the line
        Bits=''.join(Line[::-1])
        print("{0:02x}".format(int(Bits,2)),'',end='')
        Parts = Parts + 1
        if Parts >= 8:
            print()
            Parts=0

sys.exit()

print("v2.0 raw")
LongString = ['']*Height
Parts      = 0
for R in Out:   
    Y = 0
    for Line in R:
        LongString[Y] = LongString[Y] + "".join(Line) + ' '
        Y = Y+ 1
    Parts = Parts + 1
    if(Parts >= 16):
        for L in LongString:
            print(L)
        LongString = ['']*Height
        Parts = 0
        print()

##v2.0 raw
##04 04 04 04 04 04 04 04
        
#    for Y in range(len(Out)):
#        if Y < len(RepG):
#            print(RepG[Y],"".join(Out[Y]))
#        else:
#            print(" "*G.bbW,"".join(Out[Y]))

#for G in font.glyphs:
#    print(G.codepoint, G.bbH - G.bbY, len(G.data))
#    print(G.bbX, G.bbY, G.bbW,  G.bbH, G.advance)
#    print(G.bbX + G.bbW, G.bbY + G.bbH)
#    print(G.advance)        

# G.advance ..... effective width of the character; for monospace fonts identical for all glyphs

##class Glyph(builtins.object)
## |  Glyph(name, data=None, bbX=0, bbY=0, bbW=0, bbH=0, advance=0, codepoint=None)
## |
## |  Represents a font glyph and associated properties.
## |
## |  :param bytes name: The name of this glyph, ASCII encoded.
## |  :param data: the bitmap data for the glyph, as ASCII encoded hexadecimal
## |          digits.
## |  :type data: iterable of :class:`bytes`
## |  :param int bbX: The left-most edge of the glyph's bounding box, in
## |          pixels.
## |  :param int bbY: The bottom-most edge of the glyph's bounding box, in pixels.
## |  :param int bbW: The glyph's bounding-box extends this many pixels right of
## |          ``bbX`` (must be >= 0).
## |  :param int bbH: The glyph's bounding-box extends this many pixels upward
## |          from ``bbY`` (must be >= 0).
## |  :param int advance: After drawing this glyph, the next glyph will be
## |          drawn this many pixels to the right.
## |  :param int codepoint: The Unicode codepoint that this glyph represents.
## |
## |  The glyph bitmap data is an iterable of ``bytes``, where the first item
## |  represents the top row of pixels, the next item represents the next row
## |  of pixels, and so forth. There should be ``bbH`` items in total. Each
## |  item is one or more hexadecimal digits representing the pixels of that
## |  row: the first digit represents the leftmost four pixels (most
## |  significant bit to the left), the next digit represents the next four
## |  pixels, and so forth. If ``bbW`` is not an integer multiple of 4, the
## |  row should be padded with 0 bits.
## |
## |  For example, let's say we want to render a capital A, like so:
## |
## |  .. code-block:: text
## |
## |          .###.
## |          #...#
## |          #####
## |          #...#
## |
## |  We encode that pattern in binary, pad to a multiple of four bits, and
## |  convert to hexadecimal::
## |
## |          >>> raw_data = [
## |          ...     0b01110000,
## |          ...     0b10001000,
## |          ...     0b11111000,
## |          ...     0b10001000,
## |          ... ]
## |          >>> for each in raw_data:
## |          ...     print("{:X}".format(each))
## |          70
## |          88
## |          F8
## |          88
## |
## |  Therefore, to create a glyph representing that image::
## |
## |          >>> my_glyph = Glyph(
## |          ...     name=b"capital A",
## |          ...     data=[b'70', b'88', b'F8', b'88'],
## |          ...     bbW=5,
## |          ...     bbH=4,
## |          ...     advance=6,
## |          ...     codepoint=65,
## |          ... )
## |
## |  To aid debugging, the ``Glyph`` class has a ``__str__`` method that
## |  renders the glyph on a grid, with the glyph origin marked::
## |
## |          >>> print(my_glyph)
## |          |###.
## |          #...#
## |          #####
## |          #---#
## |
## |  The glyph origin isn't actually visible because it's underneath the lower
## |  left corner of the glyph, but you can see the X axis across the bottom
## |  and the Y axis up the left.
## |
## |  .. py:attribute:: advance
## |
## |          (:class:`int`)
## |          How far to the right the next glyph should be drawn, in pixels.
## |
## |  .. py:attribute:: data
## |
## |          (:class:`list` of :class:`int`) Glyph bitmap data.
## |
## |          Unlike the format passed to the constructor and returned from
## |          :meth:`get_data`, this uses a more Python-friendly format::
## |
## |                  >>> my_glyph = Glyph(
## |                  ...     name=b"capital A",
## |                  ...     data=[b'70', b'88', b'F8', b'88'],
## |                  ...     bbW=5,
## |                  ...     bbH=4,
## |                  ... )
## |                  >>> for row in my_glyph.data:
## |                  ...     print("{:05b}".format(row))
## |                  10001
## |                  11111
## |                  10001
## |                  01110
## |
## |          Each item of the ``.data`` property is a :class:`int` `bbW` bits wide,
## |          representing the pixels of a single row. The first item in ``.data`` is
## |          the lowest row in the glyph, so that list indices increase in the same
## |          direction as pixel coordinates.
## |
## |          If you want to get the actual coordinates of the glyph's drawn pixels
## |          (for example, to draw the glyph onto an image), the easiest way is to
## |          use a loop like this::
## |
## |                  ink_coords = [
## |                          (x, y)
## |                          for x in range(my_glyph.bbW)
## |                          for y in range(my_glyph.bbH)
## |                          if my_glyph.data[y] & (1 << (my_glyph.bbW - x - 1)
## |                  ]
## |
## |          You might also want to look at :meth:`iter_pixels`.
## |
## |  Methods defined here:
## |
## |  __init__(self, name, data=None, bbX=0, bbY=0, bbW=0, bbH=0, advance=0, codepoin
##t=None)
## |      Initialize self.  See help(type(self)) for accurate signature.
## |
## |  __str__(self)
## |      Return str(self).
## |
## |  get_ascent(self)
## |      Returns the distance from the Y axis to the highest point of the glyph.
## |
## |      This is zero if no part of the glyph is above the Y axis.
## |
## |      :returns: The ascent of this glyph.
## |      :rtype: :class:`int`
## |
## |  get_bounding_box(self)
## |      Returns the position and dimensions of the glyph's bounding box.
## |
## |      :returns: The left, bottom, width and height of the bounding box, as
## |              passed to the constructor.
## |      :rtype: :class:`tuple` of :class:`int`, :class:`int`, :class:`int`,
## |              :class:`int`
## |
## |  get_data(self)
## |      Returns the glyph's bitmap data.
## |
## |      This may use a different amount of padding than the value originally
## |      passed to the constructor, and hexadecimal digits may be upper-case
## |      instead of lower-case, but the meaning should be the same.
## |
## |      See also the :meth:`iter_pixels` method,
## |      which gives you a ``bool`` for each pixel,
## |      and the underlying storage in the :attr:`data` property.
## |
## |      :returns: Hex-encoded bitmap data
## |      :rtype: :class:`list` of :class:`bytes`
## |      See also the :meth:`iter_pixels` method,
## |      which gives you a ``bool`` for each pixel,
## |      and the underlying storage in the :attr:`data` property.
## |
## |      :returns: Hex-encoded bitmap data
## |      :rtype: :class:`list` of :class:`bytes`
## |
## |  get_descent(self)
## |      Returns the distance from the Y axis to the lowest point of the glyph.
## |
## |      This is zero if no part of the glyph is below the Y axis.
## |
## |      :returns: The descent of this glyph.
## |      :rtype: :class:`int`
## |
## |  iter_pixels(self)
## |      Yields the state of pixels within the bounding box.
## |
## |      This method returns an iterable of ``bbH`` rows,
## |      from the top of the glyph (large X values)
## |      to the bottom (small X values).
## |      Each row is an iterable of ``bbW`` booleans,
## |      from left to right.
## |      Each boolean is ``True`` if that pixel should be drawn,
## |      and otherwise ``False``.
## |
## |      Alternatively,
## |      you can obtain the glyph data in BDF format with :meth:`get_data()`,
## |      or access the raw bitmap via the :attr:`data` property.
## |
## |      :returns: the state of each pixel
## |      :rtype: iterable of iterable of :class:`bool`
## |
## |  merge_glyph(self, other, atX, atY)
## |      Draw another glyph onto this one at the given coordinates.
## |
## |      :param Glyph other: The other glyph to draw onto this one.
## |      :param int atX: The other glyph's origin will be placed at this X
## |              offset in this glyph.
## |      :param int atY: The other glyph's origin will be placed at this Y
## |              offset in this glyph.
## |
## |      This glyph's bounding box will be stretch to include the area of
## |      the added glyph, but the :attr:`advance` will not be modified.
## |
## |  ----------------------------------------------------------------------
## |  Data descriptors defined here:
## |
## |  __dict__
## |      dictionary for instance variables (if defined)
## |
## |  __weakref__
## |      list of weak references to the object (if defined)
##
